unit URobo2_mX4_EKON20_2Robos;

interface

{uses   #sign:Max: MAXBOX10: 23/08/2017 22:47:46 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;   }   //#locs:321

Const
  maxpoints=1000;
  sleepms=20;  {milliseconds (ms) delay between points}
  MAPPATH = ' ..\..\examples\strasbourgoutdoor2.bmp';
 //  MAPPATH = 'C:\maXbox\EKON20\EKON20_Scripts\examples\starsmap.bmp';

var //#tech:5.10perf: 0:7:38.55 threads: 6 192.168.1.53 22:47:46 4.2.6.10
  //TForm1 = class(TForm)
    Robo, Robo2: TShape;
    ResetBtn: TButton;
    StartBtn: TButton;
       procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
       procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
       procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
       procedure FormActivate(Sender: TObject);
       procedure ResetBtnClick(Sender: TObject);
       procedure StartBtnClick(Sender: TObject);
       procedure FormPaint(Sender: TObject);
  //private
    { Private declarations }
  //public { Public declarations }
  var Drawing:boolean;
    StartPoint:TPoint;
    saved, saved2:array of TPoint;
    robo2bool: Boolean;
    count, count2:integer;
    freq:int64;  //end;
    abitmap: TBitmap;

var
  Form1: TForm;

implementation

//{$R *.DFM}
//{Uses mmsystem, {to get to queryperformance functions}
  //   math; {to get to max function}

procedure FormActivate(Sender: TObject);
{Called when form is activated - do initialization stuff}
begin
  drawing:=false;
  setlength(saved,maxpoints); {initialize saved array size}
  setlength(saved2,maxpoints); {initialize saved array size}
  robo2bool:= false;
  count:=0;  {set saved point count to 0}
  count2:= 0;
  form1.doublebuffered:=true; {prevent ficker}
  resetbtnclick(sender);
  //form1.canvas.brush.bitmap:= 
  //getbitmap('C:\maXbox\EKON20\EKON20_Scripts\examples\roboline_outdoor_layer.bmp')
    {Get timer counts/sec for use in cointrolling speed later}
  queryPerformanceFrequency(freq);
  freq:= freq div 1000; {convert it to counts per ms}
end;

procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
 {Called when user presses the mouse}
begin
  Drawing:=true;
  {Set up for drawing}
    form1.canvas.moveto(x,y);
    form1.canvas.pen.width:= 9;
  if not robo2bool then begin
     form1.canvas.pen.color:=clRed;
     {increment counter and save starting point}
     inc(count);
     saved[count]:=point(x,y)
   end else begin
     form1.canvas.pen.color:=clBlue;
     inc(count2);
     saved2[count2]:=point(x,y)
  end;
end;

procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
{User moved mouse}
begin
  If drawing then begin
   form1.canvas.lineto(x,y);
    sleep(sleepms);
  if not robo2bool then begin
    inc(count);
    if count>length(saved) then setlength(saved,length(saved)+maxpoints);
      saved[count]:=point(x,y)
    end else begin  
      inc(count2);
     if count2>length(saved2) then setlength(saved2,length(saved2)+maxpoints);
      saved2[count2]:=point(x,y)
   end;
  end;
end;

procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{User released button}
begin
  Drawing:=false;
  if not robo2bool then begin
   Robo.left:=saved[1].x-robo.Width div 2;
   Robo.top:=saved[1].y-Robo.Height div 2
  end else begin
   Robo2.left:=saved2[1].x-robo2.Width div 2;
   Robo2.top:=saved2[1].y-Robo2.Height div 2
  end;
end;

procedure ResetBtnClick(Sender: TObject);
{Called to reset track}
begin
  if count>0 then begin{erase the track}
    form1.canvas.pen.color:= form1.color; {Set brush to form color}
    form1.invalidate; {This forces form to be repainted - only it will be erasing}
    count:=0; count2:= 0;
  end;
  {Move robot back out of the drawing area}
  Robo.left:=8 * form1.width div 10;  {90% across}
  Robo.top:= form1.height div 3;    {1/4 from the top}
  Robo2.left:=2 * form1.width div 10;  {90% across}
  Robo2.top:= form1.height div 2;    {1/4 from the top}
end;

procedure StartBtnClick(Sender: TObject);
var  i,drawtime:integer;
  startcount,stopcount:int64;
begin
  if not robo2bool then 
  for i:= 2 to count do begin
    {put center of robo on the point}
      Robo.left:=saved[i].x-Robo.width div 2;
      Robo.top:=saved[i].y-Robo.height div 2;
       queryperformanceCounter(startcount);{Get time before repaint}
       application.processmessages;
       queryPerformanceCounter(stopcount);{Get time after repaint}
       drawtime:=(stopcount-startcount) div freq;  {Compute ms to repaint}
       writeln('robo1 freq ms: '+itoa(drawtime))
       sleep(max(0,sleepms-drawtime));   {wait whatever time is left, if any}
    end;
    if robo2bool then  
    for i:= 2 to count2 do begin
       Robo2.left:=saved2[i].x-Robo2.width div 2;
       Robo2.top:=saved2[i].y-Robo2.height div 2;
       queryperformanceCounter(startcount);
       application.processmessages;
       queryPerformanceCounter(stopcount);
       drawtime:=(stopcount-startcount) div freq;  
       writeln('robo2 freq ms: '+itoa(drawtime))
       sleep(max(0,sleepms-drawtime));   {wait whatever time is left, if any}
   end;
end;

procedure StartBtnClick2(Sender: TObject);
{User clicked start both robots}
var  i, drawtime, maxcount:integer;
  startcount,stopcount:int64;
begin
  maxcount:= max(count, count2)
  for i:= 2 to maxcount do begin
    if i < count then begin
      Robo.left:=saved[i].x-Robo.width div 2;
      Robo.top:=saved[i].y-Robo.height div 2;
    end;
    if i < count2 then begin  
      Robo2.left:=saved2[i].x-Robo2.width div 2;
      Robo2.top:=saved2[i].y-Robo2.height div 2;
    end;
     queryperformanceCounter(startcount);{Get time before repaint}
     application.processmessages;
     queryPerformanceCounter(stopcount);{Get time after repaint}
     drawtime:=(stopcount-startcount) div freq;  {Compute ms to repaint}
     writeln('robo both freq ms: '+itoa(drawtime))
     sleep(max(0,sleepms-drawtime));   {wait whatever time is left, if any}
   end;
 end;

procedure Robo2BtnClick(Sender: TObject);
begin
  robo2bool:= not robo2bool; //switch
  if robo2bool then begin
      TBitbtn(sender).glyph.LoadFromRes(HINSTANCE,'BLUE'); 
      TBitbtn(sender).Caption := 'Second Robo'
    end else begin
      TBitBtn(sender).glyph.LoadFromRes(HINSTANCE,'RED'); 
      TBitbtn(sender).Caption := 'First Robo'
    end;       
end;

procedure FormPaint(Sender: TObject);
{Called eveytime anything visual changes on the form}
var i:integer;
begin
  {Redraw track which got erased when windows erased everything to repaint}
  If count> 1 then 
     if not robo2bool then begin
       form1.canvas.moveto(saved[1].x,saved[1].y);
       for i:=1 to count do form1.canvas.lineto(saved[i].x,saved[i].y);
     end;
      if count2> 1 then 
      if robo2bool then begin
       form1.canvas.moveto(saved2[1].x,saved2[1].y);
       for i:=1 to count2 do form1.canvas.lineto(saved2[i].x,saved2[i].y);
    end;     
  if not drawing then
    form1.canvas.draw(0,0,abitmap);       // }
end;

procedure TForm1_FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //runflag:=false;
  //inFrm.Release;
  action:=cafree;
  abitmap.Free;
  writeln('GIS Map Robo Form closed... ');
end;

procedure FormRepeat(Sender: TObject);
{Called eveytime anything visual changes on the form}
var i:integer;
begin
  {starter:= not starter;
  repeat                          
    if starter then startbtnclick(self);
  until not starter; 
  drawing:= false; }
end;

procedure loadRoboform;
begin
  Form1:= TForm.create(self)
   Robo:= TShape.create(self)   //cause of resewt in formactivate
   Robo2:= TShape.create(self)   //cause of resewt in formactivate
   with form1 do begin
     SetBounds(69,73,840,830)
     Caption:= 'mX4: Click & drag draw path, Start to make RoboX learn'
     Color := clBlack; //clBtnFace
     Font.Charset := DEFAULT_CHARSET
     Icon.LoadFromResourceName(HInstance, 'NEWDATA');
     Show;
     //OnActivate := @FormActivate
     FormActivate(self)
     OnMouseDown := @FormMouseDown
     OnMouseMove := @FormMouseMove
     OnMouseUp := @FormMouseUp
     OnPaint:= @FormPaint;
     onClose:= @TForm1_FormClose;
     //ondblclick:=  @formrepeat;
     PixelsPerInch := 96
     //TextHeight(16)
    end; 
    abitmap:= getbitmap(MAPPATH);
    with robo do begin
       parent:= form1
       setbounds(600,280,50,50)
       Brush.Color := clRed
       Shape:= stCircle 
       Brush.Style:= bsCross;
     end;
     with robo2 do begin
       parent:= form1
       setbounds(600,350,50,50)
       Brush.Color := clBlue
       Shape:= stCircle 
       Brush.Style:= bsDiagCross;
     end;
     with TBitBtn.create(self) do begin
       parent:= form1          
       setBounds(655,30,120,40)
       glyph.LoadFromRes(HINSTANCE,'TAFTERMINAL'); // CL_MPSTOP');
       font.size:= 11
       Caption:= 'Start Robo'
       OnClick:= @StartBtnClick
     end;
    with TBitBtn.create(self) do begin
       parent:= form1          
       setBounds(655,80,120,40)
       glyph.LoadFromRes(HINSTANCE,'COLS'); //TASBARCODE'); 
       font.size:= 11
       Caption:= 'Reset Robo'
       OnClick:= @ResetBtnClick
     end;
     with TBitBtn.create(self) do begin
       parent:= form1          
       setBounds(655,130,120,40)
       glyph.LoadFromRes(HINSTANCE,'RED'); 
       font.size:= 11
       Caption:= 'First Robo'
       OnClick:= @Robo2BtnClick
     end;
     with TBitBtn.create(self) do begin
       parent:= form1          
       setBounds(655,180,120,40)
       glyph.LoadFromRes(HINSTANCE,'CL_MPPAUSE'); // COLS CL_MPSTOP');
       font.size:= 11
       Caption:= 'Start Both'
       OnClick:= @StartBtnClick2
     end;
   end;

Begin //@main
  ProcessMessagesOFF;
  if not fileExists(exepath+'examples\strasbourgoutdoor2.bmp')  then 
   wGetX2('http://www.softwareschule.ch/examples/strasbourgoutdoor2.bmp',
                                  exepath+'examples\strasbourgoutdoor2.bmp');
  loadRoboform;
  {repeat 
    if starter then
      StartBtnClick(self);
   until isKeypressed;
  memo2.setfocus;   }
End.

//doc: http://www.softwareschule.ch/download/maxbox_starter45.pdf

//http://www.themoviespoiler.com/Spoilers/Gravity.html

{const
  MAXX = 40 ;
type
  ImgObj = record
    Addrs : string;
    X: Integer ;
    Y: Integer ;
  end;
var
  All : array[1..MAXX] of ImgObj ;

procedure TForm1.btn1Click(Sender: TObject);
var
  BuffBitmap :TBitmap ;
  I,j,k: Integer;
begin
  // set  all bit maps
  
  Gaztelugatxe

Wechseln zu: Navigation, Suche 

Gaztelugatxe

Gaztelugatxe
Gewsser
Atlantischer Ozean
GeographischeLage
?4326'50?N, 247'7?W
Koordinaten: 4326'50?N, 247'7?W |  | 


Lnge
270m
Breite
80m
Hchste Erhebung
50m
Einwohner
(unbewohnt)
Gaztelugatxe ist eine zum spanischen Baskenland (Provinz Bizkaia) gehrende Insel im Golf von Biskaya, die unmittelbar vor der Felsenkste der Costa Vasca zwischen den Orten Bakio und Bermeo liegt.
  ....
  // draw 40 images
  BuffBitmap := TBitmap.Create ;
  for I := 1 to MAXX do
  begin
    BuffBitmap.LoadFromFile(All[i].Addrs);
    for j := 0 to BuffBitmap.Width-1 do
      for k := 0 to BuffBitmap.Height-1 do
      begin
        Self.Canvas.Pixels[All[i].X+j,All[i].Y+k] := BuffBitmap.Canvas.Pixels[j,k] ;
      end;
  end;

  BuffBitmap.free;
end;}