{..............................................................................}
{ http://www.rosettacode.org/wiki/Gapful_numbers#only_counting                 }
{ by maXbox    #//TODO: save the doc as URL                                    }
{..............................................................................}
{..............................................................................}

program OpenOffice_API;
//https://wiki.lazarus.freepascal.org/Office_Automation
{$IFDEF FPC}
   //{$MODE DELPHI}{$OPTIMIZATION ON,ALL}
{$ELSE}
  //{$APPTYPE CONSOLE}
{$ENDIF}
 
{uses
  sysutils,// IntToStr
  strUtils;// Numb2USA aka commatize }
const
  cIdx = 5;
  tBase  = 10;
    
var  
  starts : array [0..cIdx-1] of Uint64;
        // = (100,1000*1000, 10*1000*1000,1000*1000*1000, 7123);
  counts : array [0..cIdx-1] of Uint64; // = (30, 15,15, 10, 25);
  //100|  74623687  =>    1000*1000*1000
  //100| 746236131  => 10*1000*1000*1000
  //100|7462360431  =>100*1000*1000*1000

var
  ModsHL : array[0..99] of NativeUint;
  Pow10    : Uint64;    //global, seldom used
  countLmt : NativeUint;//Uint64; only for extreme counting
  LCMsHL : array of NativeInt;
 
  
procedure filldata;
begin
  starts[0]:= 100; starts[1]:= 1000 * 1000; starts[2]:= 10*1000*1000; 
  starts[3]:= 1000*1000*1000;   starts[4]:= 7123;
  counts[0]:= 30; counts[1]:= 15; counts[2]:= 15; counts[3]:= 10;
  counts[4]:= 25;
end;  

function GCD(a, b: Int64): Int64;
var
  temp: Int64;
begin
  while b <> 0 do begin
    temp := b;
    b := a mod b;
    a := temp
  end;
  result := a
end;

function LCM(a, b: Int64): Int64;
begin
  result := (a DIV GCD(a,b)) * b;
end;
 
procedure InitLCM(Base:NativeInt);
var
  i : integer;
Begin
  For i := Base to (Base*Base-1) do
    LCMsHL[i] := LCM(i,Base);
end;

procedure OpenSSL_Test;

//uses IdHttp, IdSSLOpenSSL;
var
  s: string;
  lHTTP: TIdHTTP;
  //hc: tfphttpclient;
begin
  lHTTP := TIdHTTP.Create(nil);
  try
    lHTTP.IOHandler := TIdSSLIOHandlerSocket.create(self);  //TIdSSLIOHandlerSocketOpenSSL.Create(lHTTP);
    lHTTP.HandleRedirects := True;
    s := lHTTP.Get('https://sourceforge.net/');
    Writeln(s);
  finally
    lHTTP.Free;
  end;
  //Exception: Error connecting with SSL.
end;

procedure GetGEOMap(URL,apath: string; const Data: string);
var encodedURL: string; mapStream: TMemoryStream;
begin //encodedURL:= Format(UrlGoogleQrCode,[Width,Height,C_Level, HTTPEncode(Data)]);
  //encodedURL:= Format(UrlMapQuestAPICode2,[c_form,HTTPEncode(Data)]);
  mapStream:= TMemoryStream.create;
    try
       Wininet_HttpGet(URL, mapStream);   //WinInet
       mapStream.Position:= 0;
       writeln('stream size: '+inttostr(mapStream.size));
       writeln(StreamToString4(mapstream))
       mapStream.Savetofile(apath); // OpenDoc(apath);
       S_ShellExecute(apath,'',seCmdOpen);
    finally
       mapStream.Free;
    end;
   Writeln(FloatToStr(Fact(70)))
   Writeln(FloatToStr2(Fact(70),ffcurrency,18,6,formatSettings)) 
   //LogicalAnd( A, B : Integer) : Boolean');
end;

procedure TOfficeWriterDriver_OpenDocument(FN: String);
 var OpenParams, SaveParams, wProperties: Variant;
     objServiceManager, objDesktop, objDocument: OleVariant;
     objText, objCursor: Variant;
     rS: string;
 begin
  
  objServiceManager:= CreateOleObject('com.sun.star.ServiceManager')
  objDesktop:= objServiceManager.createInstance('com.sun.star.frame.Desktop')
  
  OpenParams:= VarArrayCreate([0, -1], varVariant);
   If (fn<>'') then FN:='file:///'+StringReplace(FN,'\','/',[rfReplaceAll])
                 else  FN:='private:factory/swriter';
     objDocument:= objDesktop.LoadComponentFromURL(FN,'_default',0,OpenParams);
      If (VarIsEmpty(objDocument) or VarIsNull(objDocument)) then
            Raise ;
            //EWordDriver.Create(Could not open document);
     //'Inserting some Text
     //'Create a text object
    objText:= objDocument.getText;
    //'Create a cursor object
    objCursor:= objText.createTextCursor;
    rS:= #13;
    objText.insertString(objCursor, 'maXbox4 at OpenOffice created text ',false)       
    //FHaveDocument:=True;
    Exit;
    writeln(' after exit ')
    
   // SaveOODocument( aDocument : Variant; aFileName : AnsiString; aFileType : AnsiString)');
    SaveOODocument(objDocument, 'maxboxoo2.odt','');
   
    //SaveParams:= VarArrayCreate([0, -1], varVariant);
    //objDocument.setName(FN); 
    SaveParams:= VarArrayCreate([0, 3], varVariant);
    //saveparams[1]:= objDocument.setPropertyValue('FilterName', 'writer_pdf_Export');
    //objCursor.setPropertyValue('BreakType',4); 
    //Function VarIsArray( const A : Variant) : Boolean;
    writeln(botoStr(VarIsArray(saveparams)));
    writeln(itoa(VarArrayDimCount(saveparams)))
    //vararr[1]:= objDocument.setPropertyValue('FilterName', 'writer_pdf_Export');
    //FN:= 'file:///'+StringReplace(FN,'\','/',[rfReplaceAll]); 
    //objDocument.Store(FN,SaveParams); 
    //Exception: [automation bridge] : com.sun.star.task.ErrorCodeIOException: .
    //wProperties := VarArrayCreate([0, 3], varVariant);
    //objDocument.StoreToURL('file:///'+ StringReplace(FN, '\', '/', [rfIgnoreCase,
                                                //rfReplaceAll]), wProperties);
  end;    



procedure SIRegister_ALOpenOffice_RunTest;
var acalcdocu, aworddocu: variant;
    objText, objCursor, saveparam: Variant;
begin
 // CL.AddClassN(CL.FindClass('TOBJECT'),'EALOpenOfficeException');
  ConnectOpenOffice;
  //DisconnectOpenOffice( aTerminateOpenOffice : boolean)');
   writeln('IsOpenOfficeConnected: '+botostr(IsOpenOfficeConnected));
 //CreateUnoService( const aServiceName : AnsiString) : Variant');
 //CreateUnoStruct( const aStructureName : AnsiString; const aMaxIndex : integer) : Variant');
 //HasUnoInterfaces( aObject : Variant; aInterfaceList : array of AnsiString) : boolean');
 //CreateOOProperties( aPropertyList : array of Variant) : Variant');
 //MakeOOPropertyValue( aPropertyName : AnsiString; aPropertyValue : Variant) : Variant');
 //acalcdocu:= CreateOOCalcDocument;      
  //aworddocu:= CreateOODrawDocument;
  aworddocu:= CreateOOWordDocument;
 
    objText:= aworddocu.getText;
    //'Create a cursor object
    objCursor:= objText.createTextCursor;
    //rS:= #13;
    objText.insertString(objCursor, 'maXbox471 at OpenOffice created Text ',false)   
 
  saveparam:= MakeOOPropertyValue('FilterName', 'writer_pdf_Export');
 
  //SaveOODocument( aDocument : Variant; aFileName : AnsiString; aFileType : AnsiString)');
  //CreateOOSheet( aDocument : Variant; const aSheetName : AnsiString)');
  //SaveOODocument(aworddocu, 'maxboxcalc4.odt', 'odt'); //ods
  //SaveOODocument(saveparam, 'maxboxcalc4.odt', 'pdf'); //ods
  //Exception: Method 'storeAsURL' not supported by automation object.
  
  DisconnectOpenOffice(false);
  writeln('IsOpenOfficeConnected: '+botostr(IsOpenOfficeConnected));
 
  //SetColumnWidth( aSheet : Variant; const aColumnIndex : integer; const aWidthInCentimetres : integer);');
  //SetColumnWidth1( aSheet : Variant; aColumn : Variant; const aWidthInCentimetres : integer);');
  //SetCellBold( aCell : Variant)');
  //SetCellBorder( aCellRange : Variant; const aBorderColor : Longword)');
  //IsVariantNullOrEmpty( aVariant : Variant) : boolean');
  //VarDummyArray : Variant');
  //ConvertToURL( aWinAddress : AnsiString) : AnsiString');
  //ConvertFromURL( aUrlAddress : AnsiString) : AnsiString');
  //OORGB( aRedByte, aGreenByte, aBlueByte : byte) : Longword');
  //ALCopyStr2(const aSourceString: AnsiString; aStart, aLength: Integer): AnsiString;');
 
  writeln(ALCopyStr2('aSourceStringOffice Tester: AnsiString',2,7));

end;

 
var i : integer;  response: TStrings;  alst: TAlstrings;
       wap: TAlWebSpider; //TWebspider; //http://sourceforge.net/projects/alcinoe
       kbc: TAlStringKeyAVLBinaryTree;
       alht: TALHttpClient; //TALWinHttpClient
       FWinInetHttpClient: TalWinInetHttpClient;
       PhpRunnerEngine: TAlPHPRunnerEngine;
       amlx: TALXMLDocument;
       
Begin    //@main
  //filldata;
  
  //GetGEOMap('https://www.example.com',Exepath+'httpstest.txt','');
  
  //GetGEOMap('https://loginc.mat.sat.gob.mx/nidp/app/login?id=XACCertiSAT&sid=0&option=credential&sid=0', Exepath+'httpstestlog.txt','');
  
  {response:= TStringlist.create;                       
  if HttpGetText('https://loginc.mat.sat.gob.mx/nidp/app/login?id=XACCertiSAT&sid=0&option=credential&sid=0',Response) then
    writeln(response.text) ; 
  response.Free;   }
  
   writeln(GetIPFromHost(gethostname));
  
   maxcalcF('330/100') 
   maxcalcF('430/130') 
   maxcalcF('496/150') 
   maxcalcF('640/193') 
   maxcalcF('795/240') 
   maxcalcF('1024/309') 
   //RSA-2048 has 617 decimal digits (2,048 bits). It  
   maxcalcF('2048/617')  
   writeln('length(bigexp: '+itoa(length(bigexp('2','2048'))))
   
   writeln(LF)
   maxcalcF('log(100)/log(2)') 
   maxcalcF('log(256)/log(2)')  
   maxcalcF('8/3') 
    maxcalcF('log(65536)/log(2)')   
    maxcalcF('16/5') 
  //100 decimal digits (330 bits).                              
  
  //openssltest
  //runjavascript
  //CoInitializeEx(0, COINIT_MULTITHREADED);
  //coinitialize(nil)
  //COINIT_MULTITHREADED
  //CoUninitializeEx //counitialize
  ///runJS
  //reverseip6
  
  //ALGetStringFromFile
    SIRegister_ALOpenOffice_RunTest;
    
End.

  Ref:
  
  procedure SIRegister_ALOpenOffice(CL: TPSPascalCompiler);
begin
 CL.AddClassN(CL.FindClass('TOBJECT'),'EALOpenOfficeException');
 Procedure ConnectOpenOffice');
 Procedure DisconnectOpenOffice( aTerminateOpenOffice : boolean)');
 Function IsOpenOfficeConnected : boolean');
 Function CreateUnoService( const aServiceName : AnsiString) : Variant');
 Function CreateUnoStruct( const aStructureName : AnsiString; const aMaxIndex : integer) : Variant');
 Function HasUnoInterfaces( aObject : Variant; aInterfaceList : array of AnsiString) : boolean');
 Function CreateOOProperties( aPropertyList : array of Variant) : Variant');
 Function MakeOOPropertyValue( aPropertyName : AnsiString; aPropertyValue : Variant) : Variant');
 Function CreateOOCalcDocument : Variant');
 Function CreateOOWordDocument: Variant;
 Function CreateOOImpressDocument : Variant');
 Function CreateOODrawDocument : Variant');
 Procedure SaveOODocument( aDocument : Variant; aFileName : AnsiString; aFileType : AnsiString)');
 Procedure CreateOOSheet( aDocument : Variant; const aSheetName : AnsiString)');
 Procedure SetColumnWidth(aSheet:Variant; const aColumnIndex: integer; const aWidthInCentimetres: integer);');
 Procedure SetColumnWidth1(aSheet: Variant; aColumn: Variant; const aWidthInCentimetres:integer);');
 Procedure SetCellBold( aCell : Variant)');
 Procedure SetCellBorder( aCellRange : Variant; const aBorderColor : Longword)');
 Function IsVariantNullOrEmpty( aVariant : Variant) : boolean');
 Function VarDummyArray : Variant');
 Function ConvertToURL( aWinAddress : AnsiString) : AnsiString');
 Function ConvertFromURL( aUrlAddress : AnsiString) : AnsiString');
 Function OORGB( aRedByte, aGreenByte, aBlueByte : byte) : Longword');
 function ALCopyStr2(const aSourceString: AnsiString; aStart, aLength: Integer): AnsiString;');
end;

Doc: https://wiki.lazarus.freepascal.org/Office_Automation

  https://www.openoffice.org/udk/common/man/tutorial/office_automation.html


// http://www.rosettacode.org/wiki/Gapful_numbers#Pascal
  
  ref http://www.rosettacode.org/wiki/Gapful_numbers#only_counting
  
  RSA-2048 has 617 decimal digits (2,048 bits). It is the largest of the RSA numbers and carried the largest cash prize for its factorization, $200,000. The largest factored RSA number is 232 decimal digits long (768 bits), and the RSA-2048 may not be factorizable for many years to come, unless considerable advances are made in integer factorization or computational power in the near future. 
  
  Base :100
Total [10000..1,000,000] : 6,039
Total [10000..100,000,000] : 251,482
Total [10000..10,000,000,000] : 24,738,934
Total [10000..1,000,000,000,000] : 2,473,436,586
Total [10000..100,000,000,000,000] : 247,343,160,115
Total [10000..10,000,000,000,000,000] : 24,734,315,489,649
Total [10000..1,000,000,000,000,000,000] : 2,473,431,548,401,507
   