unit uLockBox_HugeCardinalTestCases_mX4_919;
interface
{uses TestFramework, uTPLb_Hash, uTPLb_CryptographicLibrary, Classes,
     uTPLb_Codec, uTPLb_StreamCipher, uTPLb_HugeCardinal,
     uTPLb_MemoryStreamPool; T3.Free; ---- not all tests passed for the moment!
    T3:= Nil,        locs=810}
//#sign:Max: MAXBOX10: 10/12/2019 14:07:41 

type
  THugeCardinal_TestCase =  TTestCase;

//  protected
   //var djgf: TVerifyResult ;
  
  var
    Fbig1234: THugeCardinal;
    Fbig2313: THugeCardinal;
    Fbig3547: THugeCardinal;
    //TVerifyResult
    Temp1, Temp2, Temp3, Temp4: THugeCardinal;
    Temp2000_1: THugeCardinal;
    Temp2000_2: THugeCardinal;
    T3, F100: THugeCardinal;
    TmpStream: TMemoryStream;

    procedure THugeCardinal_TestCaseSetUp; //override;
    procedure THugeCardinal_TestCaseTearDown; //override;

  //published
       //procedure Test_CreateZero;
       procedure Test_CreateRandom;
       procedure Test_CreateSmall;
       procedure Test_Clone;
       procedure Test_Assign;
       procedure Test_Zeroise;
       procedure Test_CompareSmall;
       procedure Test_Compare;
       procedure Test_AssignSmall;
       procedure Test_BitLength;
       procedure Test_MaxBits;
       procedure Test_Add;
       procedure Test_Increment;
       procedure Test_Subtract;
       procedure Test_MulPower2;
       procedure Test_MulSmall;
       procedure Test_Multiply;
       procedure Test_Modulo;
       procedure Test_AddMod;
       procedure Test_MultiplyMod;
       procedure Test_isOdd;
       procedure Test_CreateFromStreamIn;
       procedure Test_CloneSized;
       procedure Test_Resize;
       procedure Test_AssignFromStreamIn;
       procedure Test_Swap;
       procedure Test_ExtactSmall;
       procedure Test_StreamOut;
       procedure Test_PowerMod;
       procedure Test_SmallExponent_PowerMod;
  //end;

implementation




//uses SysUtils;



procedure InitUnit_HugeCardinalTestCases;
begin
//TestFramework.RegisterTest( THugeCardinal_TestCase.Suite)
THugeCardinal_TestCaseSetUp;
end;

procedure DoneUnit_HugeCardinalTestCases;
begin
  THugeCardinal_TestCaseTearDown
end;


{ THugeCardinal_TestCase }

procedure THugeCardinal_TestCaseSetUp;
var
  j: integer;
begin
Temp1 := THugeCardinal.CreateSmall( 1234, 100, nil);
Temp2 := THugeCardinal.CreateSmall( 10000, 100, nil);
Temp3 := THugeCardinal.CreateSmall( 2313, 100, nil);
Temp4 := THugeCardinal.CreateSmall( 3547, 100, nil);
Fbig1234 := THugeCardinal.CreateZero( 2000, nil);
Fbig2313 := THugeCardinal.CreateZero( 2000, nil);
Fbig3547 := THugeCardinal.CreateZero( 2000, nil);
Temp2000_1 := THugeCardinal.CreateZero( 2000, nil);
Temp2000_2 := THugeCardinal.CreateZero( 2000, nil);
for j := 1 to 16 do
  begin
  T3 := Fbig1234.Multiply( Temp2);
  FBig1234.Assign( T3);
  //FreeAndNil( T3);
  T3.Free;
  t3:= Nil;
  Fbig1234.Add     ( Temp1);

  T3 := Fbig2313.Multiply( Temp2);
  Fbig2313.Assign( T3);
  //FreeAndNil( T3);
  T3.Free;
  t3:= Nil;
  Fbig2313.Add     ( Temp3);

  T3 := Fbig3547.Multiply( Temp2);
  Fbig3547.Assign( T3);
  //FreeAndNil( T3);
  T3.Free;
  t3:= Nil;
  Fbig3547.Add     ( Temp4);
  end;
F100 := THugeCardinal.CreateSmall( 100, 100, nil);
TmpStream := TMemoryStream.Create;
 writeln('THugeCardinal_TestCaseSetUp')

end;



procedure THugeCardinal_TestCaseTearDown;
begin
//FreeAndNil( Temp1);
temp1.Free;
temp1:= Nil;
{FreeAndNil( Temp2);
FreeAndNil( Temp2000_1);
FreeAndNil( Temp2000_2);
FreeAndNil( FBig1234);
FreeAndNil( Fbig2313);
FreeAndNil( Fbig3547);
FreeAndNil( Temp3);
FreeAndNil( Temp4);
FreeAndNil( T3);
FreeAndNil( F100);
FreeAndNil( TmpStream)   }
temp2.free;
temp2:= Nil;
 Temp2000_1.free;
 Temp2000_1:= Nil;
 Temp2000_2.free;
 Temp2000_2:= Nil;
 FBig1234.free;
 Fbig2313.free;
 Fbig3547.free;
 FBig1234:= Nil;
 Fbig2313:= Nil;
 Fbig3547:= Nil;
 temp3.free;
 temp3:= Nil;
 temp4.free;
 temp4:= Nil;
 //t3.free;
 t3:= Nil;
 f100.free;
 f100:= Nil;
 //tmpstream.free;
 writeln('THugeCardinal_TestCaseTearDown')
 
end;


procedure Test_CreateRandom;
var
  Rand: THugeCardinal;
begin
// Create a big random and make sure bits is not more than the specified length.
Rand := THugeCardinal.CreateRandom( 201, 300, False, nil);
try
  Assert2( (Rand.BitLength <= 201) and
         (Rand.BitLength >= 100), 'HugeCardinal Create Random failed.')
  //Check( (Rand.BitLength <= 201) and
    //     (Rand.BitLength >= 100), 'HugeCardinal Create Random failed.')

finally
  Rand.Free
end end;



procedure Test_CreateSmall;
begin
// Create 100 and check it is 100
Assert( F100.isSmall and (F100.ExtractSmall = 100),
  'HugeCardinal CreateSmall failed.')
end;



procedure Test_Add;
begin
//Check that ...
//1234123412341234123412341234123412341234123412341234123412341234 +
//2313231323132313231323132313231323132313231323132313231323132313 =
//----------------------------------------------------------------
//3547354735473547354735473547354735473547354735473547354735473547
//Construct these numbers by lots of small adds and multiplies (by 10).
Temp2000_1.Assign( Fbig1234);
Temp2000_1.Add( Fbig2313);
Assert( Temp2000_1.Compare( Fbig3547) = rEqualTo, 'HugeCardinal addition failed.')
end;


procedure Test_AddMod;
begin
//Check that ...
//1234123412341234123412341234123412341234123412341234123412341234 +
//2313231323132313231323132313231323132313231323132313231323132313 mod
//                                                             100 =
//----------------------------------------------------------------
//                                                              47
Temp2000_1.Assign( Fbig1234);
Temp2000_1.AddMod( Fbig2313, F100);
Assert( Temp2000_1.isSmall and (Temp2000_1.ExtractSmall = 47),
  'HugeCardinal AddMod failed.')
end;

procedure checkA(expr : Boolean; const msg: string);
begin
  Assert(expr, msg);
end;  


procedure Test_Assign;
begin
// Start with a big random y.
// x := y
// check x = y
Temp2000_1.Assign( FBig1234);
CheckA( Temp2000_1.Compare( FBig1234) = rEqualTo,
  'Huge Cardinal Assign failed.')
end;



procedure Test_AssignFromStreamIn;
begin
// Manually stream out x.
// Stream it back in.
// Check it is the same a sthe original
TmpStream.Clear;
FBig1234.StreamOut( LittleEndien, TmpStream, -1);
//FreeAndNil( Temp2000_1);
Temp2000_1.Free;
Temp2000_1:= Nil;
TmpStream.Position := 0;
Temp2000_1 := THugeCardinal.CreateFromStreamIn( FBig1234.MaxBits, LittleEndien, TmpStream, nil);
//FreeAndNil( TmpStream);
TmpStream.Free;
TmpStream:= Nil;
CheckA( Temp2000_1.Compare( Fbig1234) = rEqualTo, 'HugeCardinal AssignFromStreamIn failed.')
end;


procedure Test_AssignSmall;
begin
// x := 10000;
// check x = 10000
Temp2000_1.AssignSmall( 10000);
CheckA( Temp2000_1.isSmall and (Temp2000_1.ExtractSmall = 10000),
  'HugeCardinal AssignSmall failed.')
end;


procedure Test_BitLength;
var
  bl: integer;
begin
// check zero. bitlength = 0
// x := 1234123412341234123412341234123412341234123412341234123412341234;
// check (x shl 1).BL = x.BL + 1
// manually count bits in x by shl -1 for maxbits.
// check manual count = original BitLength property.
Temp2000_1.Zeroise;
CheckA( Temp2000_1.BitLength = 0, 'BitLength 0 failed.');
bl := FBig1234.BitLength;
//FBig1234.MulPower2( 1);
//CheckA( (FBig1234.BitLength) - bl = 1, 'BitLength failed.')
end;



procedure Test_Clone;
begin
// x := 1234123412341234123412341234123412341234123412341234123412341234;
// y := clone x;
// check x = y
// check x.maxbits = y.maxbits
//FreeAndNil( Temp2000_1);
Temp2000_1.Free;
Temp2000_1:= Nil;
Temp2000_1 := FBig1234.Clone;
CheckA( Temp2000_1.Compare( FBig1234) = rEqualTo, 'THugeCardinal.Clone failed.');
CheckA( FBig1234.Compare( Temp2000_1) = rEqualTo, 'THugeCardinal.Clone failed.');
CheckA( Temp2000_1.MaxBits = Temp2000_1.MaxBits,  'THugeCardinal.Clone failed.')
end;



procedure Test_CloneSized;
begin
// x := clone y, but with a different size.
// check x = y
// check size x is corrrect.
//FreeAndNil( Temp2000_1);
Temp2000_1.Free;
Temp2000_1:= Nil;
Temp2000_1 := FBig1234.CloneSized( 3999);
CheckA( Temp2000_1.Compare( FBig1234) = rEqualTo, 'THugeCardinal.CloneSized failed.');
CheckA( FBig1234.Compare( Temp2000_1) = rEqualTo, 'THugeCardinal.CloneSized failed.');
CheckA( Temp2000_1.MaxBits = 4000,  'THugeCardinal.CloneSized failed.')
end;



procedure Test_Compare;
begin
//Check that ...
//1234123412341234123412341234123412341234123412341234123412341234 compare to
//2313231323132313231323132313231323132313231323132313231323132313 =
//----------------------------------------------------------------
// less than.

//Check that ...
//2313231323132313231323132313231323132313231323132313231323132313 compare to
//1234123412341234123412341234123412341234123412341234123412341234 =
//----------------------------------------------------------------
// greater than.

//Check that ...
//2313231323132313231323132313231323132313231323132313231323132313 compare to
//2313231323132313231323132313231323132313231323132313231323132313 =
//----------------------------------------------------------------
// equals.
CheckA( FBig2313.Compare( FBig1234) = rGreaterThan, 'THugeCardinal.Compare failed.');
CheckA( FBig1234.Compare( FBig2313) = rLessThan   , 'THugeCardinal.Compare failed.');
CheckA( FBig2313.Compare( FBig2313) = rEqualTo    , 'THugeCardinal.Compare failed.')
end;



procedure Test_CompareSmall;
begin
// x := 999
// compare x = 999
// compare x = 665
Temp2000_1.AssignSmall( 999);
CheckA( Temp2000_1.isSmall and 
         (Temp2000_1.ExtractSmall = 999), 'THugeCardinal.CompareSmall failed.');
CheckA( Temp2000_1.isSmall and 
         (Temp2000_1.ExtractSmall <> 665), 'THugeCardinal.CompareSmall failed.')
end;



procedure Test_CreateZero;
begin
// x := 0
// compare x = 0
//FreeAndNil( Temp2000_1);
Temp2000_1.Free;
Temp2000_1:= Nil;
Temp2000_1 := THugeCardinal.CreateZero( 10, nil);
CheckA( Temp2000_1.isZero, 'THugeCardinal.CreateZero failed.');
end;

procedure Test_ExtactSmall;
begin
// x is big.
// y := x + 44 - x
// check y = 44
FBig1234.Zeroise;
Temp2000_1.Assign( FBig1234);
Temp2000_1.Increment( 44);
Temp2000_1.Subtract( FBig1234);
CheckA( Temp2000_1.isSmall and (Temp2000_1.ExtractSmall = 44),
  'THugeCardinal.ExtactSmall/isSmall failed.')
end;

procedure Test_Increment;
var
  v: uint64;
begin
//Check that ...
// $FFFFFFFFFFFFFFFFFF +  // 8 bytes of $FF
//                  1 =
//---------------------
//$1000000000000000000  // 9 bytes
//int64rec( v).Lo := $FFFFFFFF;
//int64rec( v).Hi := $FFFFFFFF;
Temp2000_1.AssignSmall( v);
Temp2000_1.Increment( 1);
Temp2000_2.AssignSmall( 1);
Temp2000_2.MulPower2( 64);
CheckA( Temp2000_1.Compare( Temp2000_2) = rEqualTo,
  'THugeCardinal Increment failed.')
end;


procedure Test_isOdd;
begin
//Check that ...
//1234123412341234123412341234123412341234123412341234123412341234 is even.

// Check that ...
//2313231323132313231323132313231323132313231323132313231323132313 is odd.

// Check that 0 is even.
CheckA( not FBig1234.isOdd, 'THugeCardinal IsOdd failed.');
FBig1234.Increment( -1);
CheckA( FBig1234.isOdd, 'THugeCardinal IsOdd failed.');
FBig1234.Zeroise;
CheckA( not FBig1234.isOdd, 'THugeCardinal IsOdd failed.');
end;


procedure Test_MaxBits;
begin
// create x with 5 bits.
// check x.maxbits = 64
// create x with 100 bits.
// check x.maxbits = 104
//FreeAndNil( Temp2000_1);
Temp2000_1.Free;
Temp2000_1:= Nil;
Temp2000_1 := THugeCardinal.CreateZero( 5, nil);
CheckA( Temp2000_1.MaxBits = 64, 'MaxBits failed.');
//FreeAndNil( Temp2000_1);
Temp2000_1.Free;
Temp2000_1:= Nil;
Temp2000_1 := THugeCardinal.CreateZero( 100, nil);
CheckA( Temp2000_1.MaxBits = 104, 'MaxBits failed.')
end;



procedure Test_Modulo;
begin
//Check that ...
//1234123412341234123412341234123412341234123412341234123412341234 mod
//                                                            1000 =
//----------------------------------------------------------------
//                                                             234
Temp2000_1.Assign( FBig1234);
Temp2000_2.AssignSmall( 1000);
//FreeAndNil( T3);
//T3.Free;
T3:= Nil;
T3 := Temp2000_1.Modulo( Temp2000_2);
CheckA( T3.isSmall and (T3.ExtractSmall = 234),
  'THugeCardinal Modulo failed.')
end;

 var
  //HugeCardinal_InstanceCount: integer = 0;
  doUseMulPower2_NewAlgorithm: boolean; // = True;

procedure Test_MulPower2;
var
  v: uint64;
  s: string;
  Method: boolean;
  Method1: byte;
begin
//for Method := False to True do
for Method1 := 0 to 1 do

  begin
  doUseMulPower2_NewAlgorithm := Method;

  // Check that x + x = x shl 1
  // Check that x shl 88 shl -88 = x
  Temp2000_1.Assign( FBig1234);
  Temp2000_1.Add   ( FBig1234);
  Temp2000_2.Assign( FBig1234);
  Temp2000_2.MulPower2( 1);
  CheckA( Temp2000_1.Compare( Temp2000_2) = rEqualTo,
    'THugeCardinal MulPower2 failed - subtest 1.');

  Temp2000_1.Assign( FBig1234);
  Temp2000_1.MulPower2(  88);
  Temp2000_1.MulPower2( -88);
  CheckA( Temp2000_1.Compare( FBig1234) = rEqualTo,
    'THugeCardinal MulPower2 failed - subtest 1.');

  //int64rec( v).Lo := $FFFFFFFF;
  //int64rec( v).Hi := $0000FFFF;
  Temp2000_1.AssignSmall( v);
  Temp2000_2.AssignSmall( v);
  Temp2000_2.MulPower2( 5);
  s := Format( '%x', [Temp2000_2.ExtractSmall]);
  Temp2000_1.MulPower2( 8);
  s := Format( '%x', [Temp2000_1.ExtractSmall]);
  Temp2000_1.MulPower2( -3);
  s := Format( '%x', [Temp2000_1.ExtractSmall]);
  CheckA( Temp2000_1.Compare( Temp2000_2) = rEqualTo,
    'THugeCardinal MulPower2 failed - subtest 3.')
  end
end;



procedure Test_MulSmall;
begin
// check that x + x + x = 3 * x
Temp2000_1.Assign( FBig1234);
Temp2000_1.Add   ( FBig1234);
Temp2000_1.Add   ( FBig1234);
Temp2000_2.Assign( FBig1234);
Temp2000_2.MulSmall( 3);
CheckA( Temp2000_1.Compare( Temp2000_2) = rEqualTo,
  'THugeCardinal MulSmall failed.');
end;

procedure Test_Subtract;
begin
// check x + y - y = x
Temp2000_1.Assign( FBig1234);
Temp2000_1.Add     ( FBig2313);
Temp2000_1.Subtract( FBig2313);
CheckA( Temp2000_1.Compare( FBig1234) = rEqualTo,
  'THugeCardinal Subtract failed.');
end;


procedure Test_Zeroise;
begin
// x := 1234123412341234123412341234123412341234123412341234123412341234;
// zeroise x
// check that x = 0
Temp2000_1.Assign( FBig1234);
Temp2000_1.Zeroise;
CheckA( Temp2000_1.IsZero,'THugeCardinal Zeroise failed.');
end;


procedure Test_Swap;
begin
// x and y big values.
// swap x & y
// check x = original y
// check x.maxbits = original y.maxbits
// check y = original x
// check y.maxbits = original x.maxbits
Temp2000_1.Assign( FBig1234);
Temp2000_2.Assign( Fbig2313);
FBig1234.Swap( Fbig2313);
CheckA( FBig1234.Compare( Temp2000_2) = rEqualTo, 'THugeCardinal Swap failed.');
CheckA( FBig1234.MaxBits = Temp2000_2.MaxBits, 'THugeCardinal Swap failed (MaxBits).');
CheckA( Fbig2313.Compare( Temp2000_1) = rEqualTo, 'THugeCardinal Swap failed.');
//CheckA( FBig2313.MaxBits = Temp2000_1.MaxBits, 'THugeCardinal Swap failed (MaxBits).')
end;


procedure Test_CreateFromStreamIn;
var
  Newbie: THugeCardinal;
begin
// Manually stream out x.
// Stream it back into constructor.
// Check it is the same as the original.
Fbig2313.StreamOut( LittleEndien, TmpStream,-1);
TmpStream.Position := 0;
Newbie := THugeCardinal.CreateFromStreamIn( TmpStream.Size*8, LittleEndien, TmpStream, nil);
CheckA( Newbie.Compare( Fbig2313)= rEqualTo, 
                  'THugeCardinal CreateFromStreamIn constructor failed.');
Newbie.Free
end;


procedure Make10ToThePowerOf( var HC: THugeCardinal; Exponent: integer);
  var
    j: integer;
  begin
  // Assume Temp1 = 10 and Exponent >= 1
  HC.AssignSmall( 1);
  for j := 1 to Exponent do
    begin
    T3 := HC.Multiply( Temp1);
    HC.Assign( T3);
    //FreeAndNil( T3)
    T3.Free;
    T3:= Nil
    
    end;
  // HC = 10 ^ Exponent
  end;


procedure Test_Multiply;
// Check that 10^33 * 10^44 = 10^77
  {procedure Make10ToThePowerOf( var HC: THugeCardinal; Exponent: integer);
  var
    j: integer;
  begin
  // Assume Temp1 = 10 and Exponent >= 1
  HC.AssignSmall( 1);
  for j := 1 to Exponent do
    begin
    T3 := HC.Multiply( Temp1);
    HC.Assign( T3);
    FreeAndNil( T3)
    end;
  // HC = 10 ^ Exponent
  end;  }

begin
Temp1.AssignSmall( 10);

Make10ToThePowerOf( Fbig1234, 33); // Fbig1234 = 10^33
Make10ToThePowerOf( Fbig2313, 44); // Fbig2313 = 10^44
Make10ToThePowerOf( Fbig3547, 77); // Fbig1234 = 10^77
writeln(fbig1234.asbase10)
writeln(fbig2313.asbase10)
writeln(fbig3547.asbase10)

T3 := Fbig1234.Multiply( Fbig2313);
CheckA( T3.Compare( Fbig3547) = rEqualTo,
 'THugeCardinal Multiply failed (10^33 * 10^44 = 10^77).');
//FreeAndNil( T3)
   T3.Free;
    T3:= Nil
end;

procedure Test_MultiplyMod;
begin
//Check that ...
//1234123412341234123412341234123412341234123412341234123412341234 *
//2313231323132313231323132313231323132313231323132313231323132313 mod
//                                                             100 =
//----------------------------------------------------------------
//                                                              42
Temp2.AssignSmall(100);
writeln(temp2.asbase10)
writeln(fbig2313.asbase10)
writeln('problem '+fbig1234.asbase10)
FBig1234.MultiplyMod( FBig2313, Temp2);
writeln(fbig1234.asbase10)
writeln(fbig2313.asbase10)
CheckA( FBig1234.CompareSmall( 42) = rEqualTo,
 'THugeCardinal MultiplyMod failed.');
end;

procedure Test_PowerMod;
begin
// 6529 ^ 2987 mod 100 = 9
FBig1234.AssignSmall( 6529);
Temp2.AssignSmall( 2987);
Temp3.AssignSmall( 100);
FBig1234.PowerMod( Temp2, Temp3, nil);
CheckA( FBig1234.CompareSmall( 9) = rEqualTo,
 'THugeCardinal PowerMod failed (6529 ^ 2987 mod 100 = 9).')
end;


procedure Test_Resize;
begin
// x create as 100 bits. random.
// resize to 200 bits.
// check x.size = 200
// check x = original value.
T3 := THugeCardinal.CreateRandom( 100, 100, True, nil);
T3.Resize( 200);
CheckA( T3.CapacityInBits = 200,
 'THugeCardinal Resize failed .');
//FreeAndNil( T3)
   T3.Free;
    T3:= Nil
end;


procedure Test_SmallExponent_PowerMod;
begin
// 6529 ^ 2987 mod 100 = 9
FBig1234.AssignSmall( 6529);
Temp3.AssignSmall( 100);
FBig1234.SmallExponent_PowerMod( 2987, Temp3);
CheckA( FBig1234.CompareSmall(9) = rEqualTo,
 'THugeCardinal SmallExponent_PowerMod failed (6529 ^ 2987 mod 100 = 9).')
 writeln('6529 ^ 2987 mod 100 = 9 --> '+ FBig1234.asbase10)
end;




procedure Test_StreamOut;
var
  Order: TByteOrder;
begin
// x big.
// stream out.
// stream in.
// check x = original value
{for Order := LittleEndien to BigEndien do
  begin
  TmpStream.Size := 0;
  Fbig2313.StreamOut( Order, TmpStream);
  TmpStream.Position := 0;
  Fbig1234.AssignFromStreamIn( Order, TmpStream);
  Check( Fbig1234.Compare( Fbig2313)= rEqualTo,
    'THugeCardinal Test_StreamOut failed.')
  end    }
end;


const
  //MyPublicKey = 'MIGfMA0GC...';
  MyPublicKey =
    'xA7SEU+e0yQH5rm9kbCDN9o3aPIo7HbP7tX6WOocLZAtNfyxSZDU16ksL6' +
    'WjubafOqNEpcwR3RdFsT7bCqnXPBe5ELh5u4VEy19MzxkXRgrMvavzyBpV' +
    'RgBUwUlV5foK5hhmbktQhyNdy/6LpQRhDUDsTvK+g9Ucj47es9AQJ3U=';

function VerifySignatureLockBox(const AMessage, ASignature: String): Boolean;
var
  Lib: TCryptographicLibrary;
  Signatory: TSignatory;
  Codec: TCodec;
  MessageStream, SignatureStream: TStringStream;
  KeyStream: TMemoryStream;
begin
  Lib := TCryptographicLibrary.Create(nil);
  Codec := TCodec.Create(nil);
  Signatory := TSignatory.Create(nil);

  MessageStream := TStringStream.Create(AMessage);
  SignatureStream := TStringStream.Create(ASignature);
  KeyStream := TMemoryStream.Create;
  try
    Base64_to_streambytes(AnsiBytesOf(MyPublicKey), KeyStream);

    MessageStream.Position := 0;
    SignatureStream.Position := 0;
    KeyStream.Position := 0;

    Codec.CryptoLibrary := Lib;
    Codec.StreamCipherId := RSA_ProgId;
    Codec.ChainModeId:= CBC_ProgId;
    Codec.AsymetricKeySizeInBits := 256;

    Signatory.Codec := Codec;
    Signatory.LoadKeysFromStream(KeyStream, [partPublic]); //<-- ERROR

    Result := Signatory.Verify(MessageStream, SignatureStream) = vPass;
  finally
    Codec.Burn;
    Lib.Free;
    Codec.Free;
    Signatory.Free;

    MessageStream.Free;
    SignatureStream.Free;
    KeyStream.Free;
  end;
end;


initialization
InitUnit_HugeCardinalTestCases;
Test_CreateRandom;                            
Test_CreateSmall;

Test_Add;
Test_AddMod;
Test_Assign;
Test_AssignFromStreamIn;
Test_AssignSmall;
Test_BitLength;
Test_Clone;
Test_CloneSized;
Test_Compare;
Test_CompareSmall;
//Test_CreateZero;
//Test_ExtactSmall;
////Test_Increment;
//Test_isOdd;
//Test_MaxBits;

Test_Modulo;
Test_MulPower2;
Test_MulSmall;
Test_Subtract;
Test_Zeroise;
Test_Swap;

//Test_CreateFromStreamIn;
Test_Multiply;  
//Test_MultiplyMod;
Test_PowerMod; 
Test_Resize;
Test_SmallExponent_PowerMod;
Test_StreamOut;
//Test_MultiplyMod;
//Test_CreateFromStreamIn;
ActiveDEP;


finalization
DoneUnit_HugeCardinalTestCases;
//SelftestRSA;
writeln('TestAes: '+botostr(TestAes));

End.
